import 'package:environmental_protection/network/requester.dart';

class UserInformation {
  late String _address;
  late String _avatar;
  late double _balance;
  late DateTime _birthday;
  late String _career;
  late String _contacts;
  late String _contactsPhone;
  late String _degree;
  late String _email;
  late String _idCard;
  late String _marriage;
  late String _nation;
  late String _nativePlace;
  late String _nickName;
  late String _organization;
  late String _phonenumber;
  late String _realName;
  late String _registerPlace;
  late String _sex;
  late int _userId;
  late int _userName;

}
class GlobalInformation {
  String _token = "";
  UserInformation _userInformation = UserInformation();
  final Requester _requester = Requester();
  static final Uri baseUrl = Uri.parse("http://124.93.196.45:10091/Neusoft/community/");
  final Set<void Function(void Function())> _setStates = {};
  _setState(){
    for (var e in _setStates) {
      e((){});
    }
  }
  String get token => _token;
  UserInformation get userInformation => _userInformation;
  Requester get requester => _requester;
  set token(String token){
    _setState();
    _token = token;
  }
  set userInformation(UserInformation userInformation){
    _setState();
    _userInformation = userInformation;
  }
  static GlobalInformation? _globalInformation;
  static GlobalInformation getInstance([void Function(void Function())? setState]){
    _globalInformation ??= GlobalInformation();
    assert(_globalInformation != null);
    if (setState != null){
      _globalInformation!._setStates.add(setState);
    }
    return _globalInformation!;
  }
}

Uri resolve(String uri){
  if (uri.startsWith("/")){
    uri = uri.replaceFirst("/", "");
  }
  print(uri);
  return GlobalInformation.baseUrl.resolve(uri);
}