import 'package:environmental_protection/common/user_information.dart';
import 'package:http/http.dart';

class Requester extends BaseClient {
  final Client _inner = Client();
  @override
  Future<StreamedResponse> send(BaseRequest request) {
    var information = GlobalInformation.getInstance();
    if (information.token.isNotEmpty){
      request.headers['Authorization'] = information.token;
    }
    request.headers['Content-Type'] = 'application/json';
    return _inner.send(request);
  }

}